	.include "p30f2012.inc"
	.global	lcd_init
	.global	Hyoji
	.global	HyojiInit
	.global	CurHome
	.global	w1s
	.global	w2ms
	.global	w4ms
	.global	w4us
	.global	w40us
;------------------------------------
;--  LCD
;------------------------------------
lcd_init:
	call	w4ms		;wait16ms
	call	w4ms
	call	w4ms
	call	w4ms
	mov	#0x30,w0	;LCDt@NVZbg1
	bclr	PORTC,#13	;RS=L
	call	lcd_w1c
	call	w2ms

	mov	#0x30,w0	;LCDt@NVZbg2
	bclr	PORTC,#13	;RS=L
	call	lcd_w1c
	call	w2ms

	mov	#0x30,w0	;LCDt@NVZbg3
	bclr	PORTC,#13	;RS=L
	call	lcd_w1c
	call	w2ms

;-----ݒ----
	mov	#0x20,w0	;LCDt@NVZbg4
	bclr	PORTC,#13	;RS=L
	call	lcd_w1c
	call	w2ms

	mov	#0x28,w0	;LCDt@NVZbg5
	bclr	PORTC,#13	;RS=L
	call	lcd_w1c
	sl	w0,#4,w0
	call	lcd_w1c
	call	w2ms

	mov	#0x0f,w0	;\nm
	bclr	PORTC,#13	;RS=L
	call	lcd_w1c
	sl	w0,#4,w0
	call	lcd_w1c
	call	w2ms

	mov	#0x06,w0	;Gg[[h
	bclr	PORTC,#13	;RS=L
	call	lcd_w1c
	sl	w0,#4,w0
	call	lcd_w1c
	call	w2ms

	mov	#0x01,w0	;\NA =L
	bclr	PORTC,#13	;RS=L
	call	lcd_w1c
	sl	w0,#4,w0
	call	lcd_w1c
	call	w2ms
	return

CurHome:
	push	w0
	mov	#0x02,w0	;J[\z[ɂB
	bclr	PORTC,#13	;RS=L
	call	lcd_w1c
	sl	w0,#4,w0
	call	lcd_w1c
	call	w2ms
	pop	w0
	return

CurHome2:
	push	w0
	mov	#0x80,w0	;J[\QsڂɂB
	bclr	PORTC,#13	;RS=L
	call	lcd_w1c
	sl	w0,#4,w0
	call	lcd_w1c
	call	w40us
	pop	w0
	return

;\f[^obt@̏
HyojiInit:
	push	w0
	push	w1
	push	w2
	push	w3
	mov	#psvpage(HTMP),w0
	mov	w0,_PSVPAG
	mov	#psvoffset(HTMP),w1
	mov	#0x800,w2
	repeat	#31
	mov.b	[w1++],[w2++]
	pop	w3
	pop	w2
	pop	w1
	pop	w0
	return

;---- 2sƂ-----------------
Hyoji:	push	w0
	push	w1
	push	w2
	call	CurHome2
	mov	#0x800,w1	;1s
	mov	#16,w2
kakil1:	mov.b	[w1++],w0
	bset	PORTC,#13	;RS=L
	call	lcd_w1c
	sl	w0,#4,w0
	call	lcd_w1c
	call	w40us
	dec	w2,w2
	bra	nz,kakil1
	mov	#0xC0,w0	;J[\QsڂɂB
	bclr	PORTC,#13	;RS=L
	call	lcd_w1c
	sl	w0,#4,w0
	call	lcd_w1c
	call	w40us
	mov	#16,w2		;2s
kakil2:	mov.b	[w1++],w0
	bset	PORTC,#13	;RS=L
	call	lcd_w1c
	sl	w0,#4,w0
	call	lcd_w1c
	call	w40us
	dec	w2,w2
	bra	nz,kakil2
	pop	w2
	pop	w1
	pop	w0
	return

;-----LCD1oCgo-----
; In=w0
;--------------------------
lcd_w1c:
	push	w2
	bset	PORTD,#9	;E=H
	mov	w0,w2
	and	#0x00f0,w2
	sl	w2,#2,w2
	mov	w2,PORTB
	mov	w2,PORTB
	bclr	PORTD,#9	;E=L
	pop	w2
	return

;-----4us҂(2.5us)-----
w4us:	push	w3
	mov	#30,w3
w4usl:	dec	w3,w3
	bra	nz,w4usl
	pop	w3
	return

;-----40us wait-----
w40us:	push	w3
	mov	#400,w3
w40usl:
	dec	w3,w3
	bra	nz,w40usl
	pop	w3
	return

;-----1ms҂-----
w1ms:	push	w3
	mov	#10000,w3
w1msl:	dec	w3,w3
	bra	nz,w1msl
	pop	w3
	return

;-----2ms҂-----
w2ms:	push	w3
	mov	#20000,w3
w2msl:	dec	w3,w3
	bra	nz,w2msl
	pop	w3
	return

;-----4ms҂-----
w4ms:	push	w3
	mov	#0x9250,w3
w4msl:	dec	w3,w3
	bra	nz,w4msl
	pop	w3
	return

;-----1s҂-----
w1s:	push	w3
	mov	#250,w3
w1sl:	call	w4ms
	dec	w3,w3
	bra	nz,w1sl
	pop	w3
	return

HTMP:	.ascii	"            m/s "
	.ascii	"            km/h"

	.END
