	.include "p30f2012.inc"
	.global	ADinit
	.global	GetAD
	.global	Bin2Dec

	.equ	CNV,2
	.equ	SCK,3

;------------------------------------
; AD
;  Input=Non
;  Output=Non
;------------------------------------
ADinit:
	bclr	PORTF,#CNV
	bclr	PORTF,#CNV
	bclr	PORTF,#SCK
	nop
	return

;------------------------------------
; f[^擾
;  Input=Non
;  Output=data:XIN..ZIN
;------------------------------------
GetAD:
	push	w0
	push	w1
	push	w2
	push	w3
	mov	#16,w0
	bclr	PORTF,#CNV
	nop

GADL:	bset	PORTF,#SCK	;SCKʲ
	sl	w1,#1,w1	;ް
	sl	w2,#1,w2
	sl	w3,#1,w3
	btsc	PORTB,#0
	bset	w1,#0
	btsc	PORTB,#1
	bset	w2,#0
	btsc	PORTB,#2
	bset	w3,#0
	bclr	PORTF,#SCK
	dec	w0,w0
	bra	nz,GADL

	bset	PORTF,#CNV
	mov	#0x8000,w0
	add	w0,w1,w1
	add	w0,w2,w2
	add	w0,w3,w3

	mov	w1,XIN
	mov	w2,YIN
	mov	w3,ZIN

	pop	w3
	pop	w2
	pop	w1
	pop	w0
	return


; 0`0xffff:16i10iϊĕ\obt@ɓWJ
Bin2Dec:	;w3=input,w4=input
	push	w0
	push	w1
	push	w2
	push	w4
	push	w5

	mov	w3,w5
	btsc	w3,#15
	neg	w3,w3
	mov	#10,w2
	repeat	#17
	div.u	w3,w2	;output=w0
	add	#0x30,w1
	mov.b	w1,[w4--]

	mov	#0x2e,w1	;_
	mov.b	w1,[w4--]

	mov	w0,w3
	repeat	#17
	div.u	w3,w2	;output=w0
	add	#0x30,w1
	mov.b	w1,[w4--]
	mov	w0,w3
	repeat	#17
	div.u	w3,w2	;output=w0
	add	#0x30,w1
	mov.b	w1,[w4--]
	mov	w0,w3
	repeat	#17
	div.u	w3,w2	;output=w0
	add	#0x30,w1
	mov.b	w1,[w4--]

	mov	#0x20,w1
	btsc	w5,#15
	mov	#0x2d,w1
	mov.b	w1,[w4--]

	pop	w5
	pop	w4
	pop	w2
	pop	w1
	pop	w0
	return

	pop	w4
	pop	w2
	pop	w1
	pop	w0
	return

	.END
